/****************************************************************************
** $Id: qobjcoll.h,v 2.2 1996/10/24 14:46:14 hanord Exp $
**
** Definition of QObject and QMetaObject collections
**
** Created : 940807
**
** Copyright (C) 1992-1997 Troll Tech AS.  All rights reserved.
**
** This file is part of the non-commercial distribution of Qt 1.2.
**
** See the file LICENSE included in the distribution for the usage
** and distribution terms, or http://www.troll.no/qt/license.html.
**
** (This file differs from the one in the commercial distribution of
** Qt only by this comment.)
**
*****************************************************************************/

#ifndef QOBJCOLL_H
#define QOBJCOLL_H

#include "qmetaobj.h"
#include "qlist.h"
#include "qdict.h"


// QObject collections

typedef Q_DECLARE(QListM,QObject)	    QObjectList;
typedef Q_DECLARE(QListIteratorM,QObject)   QObjectListIt;


// QMetaObject collections

typedef Q_DECLARE(QDictM,QMetaObject)	    QObjectDictionary;

extern QObjectDictionary *objectDict;		// global object dictionary
						// defined in qmetaobj.cpp

#endif // QOBJCOLL_H
